%ext kdr

#########################################################
#PATCHES FOR 'KEEN DREAMS 2: ANOTHER HELPING OF VEGGIES'#
#########################################################

###############
#BASIC PATCHES#
###############

#Few file names
%patch $23DFD "KDR2.CMP" $00  #Title screen archive

#Screen:
%patchfile $124B1 "KDREAMS2.DAT"	#Screen code
%patchfile $32AD0 "KDREAMS2.SCN"	#Screen text

#Ignore LOADSCN.EXE, never display error message
%patch $39C0 $B8 $0001W  $50 $9A $000004CARL    $44 $44 $5E $5D $CB

#Ignore START.EXE
%patch $3BD1 $EB

%egahead EGAHEAD.KD2
%patchfile $29846 EGADICT.KD2

%patch $B7DD  $2809W #Text called from
%patch $26279 "KDR2.EGA" $00

%patchfile $1FC46 KDREAMS2.TLI	#New tile properties

#Nullify the MAPDICT:
%patchfile $29C46 "MAPDICT.KD2"
#And patch the maphead
%patchfile $1FA50 "MAPHEAD.KD2"

#Main mapfile
%patch $2629E "KDR2.MAP" $00

#Audio file
%patch $262C2 "KDR2.AUD" $00


######################
#LONGER HELP SECTIONS#
######################

#New location of first help text segment
%patch $15642 $16C9RW
%patch $15647 $0000W

#New location of second help text segment
%patch $1564E $1788RW
%patch $15653 $0000W

#Location of third help text segment
%patch $1565A $229ERW
%patch $1565F $0000W

#First help text
%patchfile $16C90 "HELP.KD2"

#Second help text
%patchfile $17880 "HELP2.KD2"

#Third help text
%patchfile $229E0 "HELP3.KD2"


########
#LEVELS#
########

#Level name pointers: 
%patch $23E48 $5A $05 #Land of Tuberia... 
              $6E $05 
              $7F $05 
              $8F $05 
              $9E $05 
              $AD $05 
              $58 $06 
              $C2 $05 
              $64 $06 
              $91 $06
              $E0 $05 
              $73 $06 
              $F5 $05 
              $7F $06 
              $12 $06 
              $1F $06 
              $2F $06 
              $6D $05 
              $3E $06 
              $00 $00 

#Level names 
%patch $23FCA "    New Tuberia    " $00
%patch $23FDE "    Corn Park   " $00
%patch $23FEF " Blueberry Hill" $00
%patch $23FFF "Eggplant Court" $00
%patch $2400E " Kumquat Chasm" $00
%patch $2401D "Mushroom Pit" $00
%patch $240C8 "Pear Street" $00
%patch $24032 "Asparagia" $00
%patch $240D4 " Fort Tuberia " $00
%patch $24101 "Cantaloupe Mine" $00
%patch $24050 "Fruit Woods" $00
%patch $240E3 " Bean Field" $00
%patch $24065 "  Blue Tomato Zone " $00
%patch $240EF "White Carrot Path" $00
%patch $24082 "Cave of Owls" $00
%patch $2408F "Royal Residence" $00
%patch $2409F "  Lower Hill  " $00


###############
#MISCELLANEOUS#
###############

#Main menu point text changes
%patch $291F2 "  Really Start a New Game  " $00
%patch $29199 "        Start a New Game          " $00
%patch $29478 "Help Me, I'm Lost! What To Do?" $00
%patch $29497 "    About The Game's Stuff    " $00
%patch $294DA "      Read The Story      " $00

#Don't display red 'Press F1' text when idling in menu
%patch $16875 $EB

#Help text footer now green
%patch $1561D $05

#Extend the range of levels to hold place for the Boobus Bomb message on the map
%patch $6A4B $13 $7F

#New map sprite that activates message
%patch $6A50 $13 $75

#New sprite code pointer for Map Keen
%patch $4A03 $02D4W #Map Keen

#Boobus Bomb text now became a clue message
%patch $2513E  "You'll need 12-12 "		$0A
               " Flower Powers to defeat"	$0A
               " the two giant potatoes."	$00

#Exit to Tuberia changed text
%patch $24593 "Exit to New Tuberia" $00

#Don't display Boobus Bombs near message
%patch $4C07 $EB $32

#Flower Power vanishes when hitting solid tiles
%patch $6964 $0000W

#Level loading name color is green
%patch $C598 $05

#Play sound when new game starts
%patch $3C04 $33 $C0 $A3 $70EEW  $A3 $7124W  $A3 $7116W  $A3 $7114W  $A3 $7116W
                 $A3 $711AW  $A3 $711CW  $A3 $711EW  $C7 $06 $7118W  $4E20W
             $C7 $06 $7126W  $0003W  $B8 $000DW $50 $9A $10BB1282RL $44 $44 $90

#Rectangle colors
%patch $5A7E $001AW #Light green


###############
#STATUS WINDOW#
###############

#Play sound when Status Window appears
%patch $3E8E  $0014W  $50 $9A $10BB1282RL

#Status window - size
%patch $3CD0 $0005W #Height
%patch $3CD4 $0016W #Width

#F10 + I cheat: Status Window bomb counter replaced by the Flower Power
%patch $382F $711CW  $0063W

#Status Window bomb counter replaced by the Flower Power
%patch $3DB5 $711CW

#Level that decides between Flower Power and Bombs counter
%patch $6192 $8F3EW $11 $75

#Level that decides between Flower Power and Bombs tiles
%patch $5EF8 $8F3EW $11 $75

#Dropped 'Boobus Bombs' (now Flower Powers) turn into items
%patch $6955 $0000W


##############
#MENU-RELATED#
##############

#Main menu actions
%patch $28424 $0008W $0010W $0030W $0030W $0002W $0004W $000AW $56AAW #Start a Game
              $0000W $0000W $11FA2BACRL   $0000W
%patch $2843E $0008W $0030W $0030W $0050W $0002W $0009W $000FW $56C1W #Get Help
              $0000W $0000W $11FA2BACRL   $0000W
%patch $28458 $0008W $0050W $0030W $0070W $0002W $0006W $000CW $56DEW #Load / Save / Quit
              $0000W $0000W $11FA2BACRL   $0000W
%patch $28472 $0008W $0070W $0030W $0090W $0002W $0007W $000DW $56F1W #Choose Controls
              $002EW $0000W $11FA2BACRL   $0000W
%patch $2848C $0008W $0090W $0030W $00B0W $0002W $0008W $000EW $5701W #Select Sound Device
              $003CW $0000W $11FA2BACRL   $0000W
%patch $284A6 $FFFFW $FFFFW $FFFFW $FFFFW $0000W $0000W $0000W $0000W #END
              $0000W $0000W $00000000L    $0000W

#Choose difficulty menu actions
%patch $28528 $0098W $0060W $00DAW $009FW $0001W $002DW $002EW $5782W #Easy
              $0000W $0000W $11FA3DD0RL   $0000W
%patch $28542 $FFFFW $FFFFW $FFFFW $FFFFW $0000W $0000W $0000W $0000W #END
              $0000W $0000W $00000000L    $0000W

#Sound menu excludes Sound Source and Sound Blaster options
%patch $289EE $0080W $0010W $00A0W $0028W $0002W $0013W $001CW $59D2W #No sound
              $0000W $0000W $11FA3C60RL   $0000W
%patch $28A08 $00A8W $0010W $00C8W $0028W $0002W $0014W $001DW $59E1W #PC
              $0000W $0000W $11FA3C60RL   $0000W
%patch $28A22 $00D0W $0010W $00F0W $0028W $0002W $0015W $001EW $59F0W #AdLib
              $0000W $0000W $11FA3C60RL   $0000W
%patch $28A3C $FFFFW $FFFFW $FFFFW $FFFFW $0000W $0000W $0000W $0000W #END
              $0000W $0000W $00000000L    $0000W

#Help menu actions
%patch $285C4 $0080W $0010W $00A0W $0028W $0001W $003DW $003EW $5A08W #Help Me
              $003BW $0000W $11FA3631RL   $0000W
%patch $285DE $00A8W $0010W $00C8W $0028W $0001W $003BW $003CW $5A27W #Controls
              $0000W $0000W $11FA3631RL   $0000W
%patch $285F8 $00D0W $0010W $00F0W $0028W $0001W $0039W $003AW $5A6AW #Tips
              $0000W $0000W $11FA3631RL   $0000W
%patch $28612 $FFFFW $FFFFW $FFFFW $FFFFW $0000W $0000W $0000W $0000W #END
              $0000W $0000W $00000000L    $0000W


################
#COMMANDER KEEN#
################

#Map Keen walking frequency
%patch $248C2 $0006W

#Remove Keen's Zzzzz sequence
%patch $6EA4  $0000W
%patch $2490A $0000W
%patch $24928 $0000W
%patch $24946 $0000W

#Keen's bored animation is Keen 4-type
%patch $6DE0 $0EF6W #Bored Keen looking up action
%patch $6E22 $1040W #Bored Keen napping action

#Keen's looks up sequence
%patch $24966 $0062W $0058W
%patch $24970 $003CW        #Animation speed

#Keen stand-blink-shrug
%patch $249FC $005AW $005AW
%patch $24A06 $005AW        #Animation speed
%patch $24A1A $0059W $0059W
%patch $24A24 $000AW        #Animation speed
%patch $24A38 $005AW $005AW
%patch $24A42 $005AW        #Animation speed
%patch $24A56 $0059W $0059W
%patch $24A60 $000AW        #Animation speed
%patch $24A74 $005AW $005AW
%patch $24A7E $005AW        #Animation speed
%patch $24A92 $005BW $005BW
%patch $24A9C $0046W        #Animation speed

#Keen naps in two different directions
%patch $24AB0 $0071W $005CW
%patch $24ABA $0014W        #Animation speed
%patch $24ACE $0072W $005FW
%patch $24AD8 $0014W        #Animation speed
%patch $24AEC $0073W $0060W
%patch $24AF6 $0078W        #Animation speed
%patch $24B0A $0074W $0061W
%patch $24B14 $0078W        #Animation speed

#Keen yawn
%patch $24984 $006BW $0066W
%patch $2498E $0028W        #Animation speed
%patch $249A2 $0078W $0067W
%patch $249AC $0028W        #Animation speed
%patch $249C0 $0079W $0068W
%patch $249CA $0028W        #Animation speed
%patch $249DE $007AW $0069W
%patch $249E8 $0028W        #Animation speed

#Keen crouch
%patch $24BBE $00A4W $00A4W
%patch $24BC8 $0000W        #Animation speed
%patch $24BDC $00A4W $00A4W
%patch $24BE6 $0000W        #Animation speed

#Keen look up
%patch $24BA0 $0062W $0058W
%patch $24BAA $0000W        #Animation speed

#Keen fall
%patch $24F42 $00C4W $006AW
%patch $24F4C $0000W        #Animation speed
%patch $24F60 $0065W $005EW
%patch $24F6A $0000W        #Animation speed
%patch $24F7E $0064W $005DW
%patch $24F88 $0000W        #Animation speed

#Keen dying produces a shot, 1st frame is short, goes to 3rd
%patch $24B56 $05E815D8RL
%patch $24B50 $0001W
%patch $24B62 $1112W
%patch $24B82 $FFFFW $FFFFW

#Deathshot is unique
%patch $7643 $0001W  $50 $EB $B0

#Deathshot action -fall ofscreen
%patch $24B64 $0088W $0082W $0002W $0000W $0000W $0000W $0000W $0000W
              $07C501A4RL   $00000000L    $07C5022DRL   $10F4W

#Keen Dreams shooting code modified to handle deaths
%patch $6369 $55 $8B $EC $4C $4C $56 $57 $8B $76 $06 $8B $7E $08
             $B8 $0001W  $50 $9A $044D01C9RL     $44 $44 $8B $1E $3E
             $70 $C7 $07 $0002W  $8B $46 $0A $89 $47 $40 $89 $77 $0A $89 $7F
             $0C $8B $C6 $B1 $08 $D3 $E8 $89 $47 $30 $89 $47 $2C $8B $C7 $D3
             $E8 $89 $47 $32 $89 $47 $2E $C7 $47 $10 $FFFFW  $8B $5E $0A $83
             $FB $06 $77 $45 $D1 $E3 $2E $FF $A7 $0622W  $8B $1E $3E $70 $C7
             $47 $16 $0000W  $C7 $47 $18 $FFC0W  $EB $2E $8B $1E $3E $70 $C7
             $47 $16 $0040W  $C7 $47 $18 $FFECW  $EB $1E $8B $1E $3E $70 $C7
             $47 $16 $0000W  $C7 $47 $18 $0040W  $EB $0E $8B $1E $3E $70 $C7
             $47 $16 $FFC0W  $C7 $47 $18 $FFECW  $B8 $000EW  $83 $3E $8F3EW
             $FF $74 $1E

#Here we make shots -Flower Power only
%patch $6407 $83 $3E $711CW  $00 $74 $39 $FF $0E $711CW  $B8 $0004W  $8B $1E
             $3E $70 $C7 $47 $3E $0008W  $C7 $46 $FE $0BD2W  $EB $27 $83 $3E
             $711EW  $00 $74 $1B $FF $0E $7120W  $FF $0E $711EW  $B8 $0014W
             $8B $1E $3E $70 $C7 $47 $3E $000AW  $C7 $46 $FE $0C0EW  $EB $05
             $C7 $46 $FE $0000W  $50 $9A $10BB1282RL     $44 $44
             $8B $1E $3E $70 $C7 $47 $02 $0003W  $FF $76 $FE $FF $36 $3E $70
             $9A $044D1212RL     $83 $C4 $04 $5F $5E $8B $E5 $5D $CB

#Special death coding
%patch $6472 $8B $1E $3E $70 $C7 $47 $16 $0020W  $C7 $47 $18 $FFB0W  $C7 $47
             $06 $0000W  $C7 $47 $10 $FFFFW  $C7 $07 $000FW  $C7 $46 $FE $10F4W
             $83 $36 $10F4W  $01 $EB $BA

#Shot direction list
%patch $64A2 $053FW #Upwards
             $05F2W #Death
             $054FW #Rightwards
             $057FW #INVALID
             $055FW #Downwards
             $057FW #INVALID
             $056FW #Leftwards

#New MapKeen_Walk tcol, merges with Keen_Walk =$05E805A5RL
%patch $6425 $55 $8B $EC $56 $8B $76 $06 $E9 $1611W  $90

#Change MapKeen_Walk tcol to make noise
%patch $248D0 $05E805A5RL

#Keen stand-blink-shrug
%patch $249FC $00A6W $005AW
%patch $24A06 $005AW        #Animation speed
%patch $24A1A $00A5W $0059W
%patch $24A24 $000AW        #Animation speed
%patch $24A38 $00A6W $005AW
%patch $24A42 $005AW        #Animation speed
%patch $24A56 $00A5W $0059W
%patch $24A60 $000AW        #Animation speed
%patch $24A74 $00A6W $005AW
%patch $24A7E $005AW        #Animation speed
%patch $24A92 $00A7W $005BW
%patch $24A9C $0046W        #Animation speed

#Keen makes a sound when he walks
%patch $7A17 $EB $25 $83 $7C $38 $00 $75 $06 $83 $7C $3C $00 $74 $1B $C7 $44
             $1A $0000W  $C7 $44 $1E $0ED8W  $A1 $0ED8W  $83 $7C $0E $01 $75
             $03 $A1 $0EDAW  $89 $44 $20 $EB $27 $FF $06 $0368W  $B8 $0003W
             $81 $3E $0368W  $0005W  $74 $10 $81 $3E $0368W  $0005W  $7C $10
             $33 $C0 $A3 $0368W  $B8 $0003W  $50 $9A $10BB1282RL     $44 $44
             $E9 $FF45W


#########################
#QUEEN BUSTLING TUBERINA#
#########################

#Trooper is always lethal
%patch $791E $19A5W

#Trooper doesn't attack Keen
%patch $8735 $5F $5E $5D $CB

#Spawn height:
%patch $86AB $FA80W #88 pixels up

#Dying Trooper actions, makes smoke 2488W
%patch $25EF8 $011DW $011DW $0000W $0000W $0000W $0004W $0000W $0000W
              $08680CD4RL   $00000000L    $07C501DDRL   $2488W

#Tater trooper has Boobus-like death
%patch $65CE $06F5W #Tater Trooper
%patch $65E6 $06FFW #Boobus Tuber
%patch $6575 $FF $4C $44 $75 $2E $B8 $2488W  $EB $08
             $FF $4C $44 $75 $24 $B8 $246AW  $50 $56 $9A $07C50255RL     $B8
             $C350W  $50 $9A $044D090ERL     $9A $044D090ERL     $83 $C4 $06 
             $C7 $04 $0019W  $C7 $44 $3E $0000W  $B8 $0009W  $50 $9A
             $10BB1282RL     $B8 $0C4AW  $50 $57 $9A $07C50255RL     $83 $C4
             $06 $5F $5E $5D $CB

#Tater Trooper's health (12)
%patch $86D0 $44 $00CW

#Boobus and Trooper share a death, Boobus wins game
%patch $9354 $55 $8B $EC $56 $8B $76 $06 $FF $44 $3E $8B $44 $3E $3D $003CW
             $7E $22 $8B $44 $20 $3D $0125W  $7D $07 $C7 $44 $1E $24C4W  $EB
             $05 $C7 $44 $1E $24A6W  $8B $C6 $05 $0046W  $50 $9A $0E450F7ARL
             $44 $44 $90


#########
#BABERRY#
#########

#Pea brain walk
%patch $25D18 $0160W $0160W
%patch $25D22 $000AW        #Animation speed
%patch $25D36 $0161W $0161W
%patch $25D40 $000AW        #Animation speed
%patch $25D54 $0161W $0161W
%patch $25D5E $000AW        #Animation speed
%patch $25D72 $0162W $0162W
%patch $25D7C $000AW        #Animation speed

#Place Pea Brain in level -fall to ground
%patch $9191 $228AW


##############
#WHITE CARROT#
##############

#Carrot spawn height
%patch $8402 $FD00W #16 pixels upwards

#New collision: Carrot pushes the door and items TO THE RIGHT only
%patch $25606 $07C5036ERL
%patch $25624 $07C5036ERL
%patch $25642 $07C5036ERL
%patch $25660 $07C5036ERL

#Change cache
%patch $23E7C $0105W #Carrot cache start
%patch $23EA8 $010EW #Carrot cache end

#Carrot run- adjust speed and animations
%patch $255F2 $0105W $0107W
%patch $255FC $0013W        #Animation speed
%patch $25610 $0106W $0108W
%patch $2561A $0013W        #Animation speed

#Carrot doesn't jump at platform edges
%patch $2560A $07C50299RL
%patch $25628 $07C50299RL

#2 frame running animation
%patch $2562C $1B82W


#############
#BLUE TOMATO#
#############

#Blue Tomato has 4 frames of animation (Use two carrot frames)
%patch $255B6 $0101W $0104W $0003W $0000W $0000W $001DW $0000W $0000W
              $07C5064BRL   $00000000L    $07C506C4RL   $1B64W
%patch $255D4 $0102W $0103W $0003W $0000W $0000W $001DW $0000W $0000W
              $07C5064BRL   $00000000L    $07C506C4RL   $1B46W
%patch $2562E $0103W $0102W $0003W $0000W $0000W $001DW $0000W $0000W
              $07C5064BRL   $00000000L    $07C506C4RL   $1B64W
%patch $2564C $0104W $0101W $0003W $0000W $0000W $001DW $0000W $0000W
              $07C5064BRL   $00000000L    $07C506C4RL   $1B46W

#Change cache
%patch $23E7A $0101W #Tomatooth cache start
%patch $23EA6 $0104W #Tomatooth cache end

#Tomatooth horizontal speed
%patch $82A3 $0019W


##########
#PINK OWL#
##########

#Cart flies in the air
%patch $87DF $75
%patch $87F2 $75

#Cart spawn height
%patch $87A5 $FF0FW #3 pixels upwards

#Moving animation speed
%patch $2584A $0125W $0125W
%patch $25854 $000FW        #Animation speed
%patch $25868 $0126W $0126W
%patch $25872 $000FW        #Animation speed

#Pink Owl speed
%patch $25856 $0010W $0000W
%patch $25874 $0010W $0000W


######
#CORN#
######

#Corn walking without charging behavior code
%patch $893E $55 $8B $EC $56 $57 $8B $76 $06 $8B $44 $0C $8B $1E $34 $70 $2B
             $47 $0C $99 $33 $C2 $2B $C2 $3D $0008W  $7E $14 $9A $16C40026RL
                 $3D $0008W  $7D $4A $8B $44 $0E $F7 $D8 $89 $44 $0E $EB $40
             $8B $1E $34 $70 $8B $47 $0A $2B $44 $0A $8B $F8 $81 $FF $F800W
             $7D $05 $C7 $44 $0E $FFFFW  $81 $FF $FC00W  $7D $0C $C7 $44 $0E
             $FFFFW  $C7 $44 $1E $1F06W  $EB $17 $81 $FF $0800W  $7D $0C $C7
             $44 $0E $0001W  $C7 $44 $1E $1F06W  $EB $05 $C7 $44 $0E $0001W
             $5F $5E $5D $CB

#Walking cycle
%patch $258A2 $1EACW
%patch $258C0 $1ECAW
%patch $258DE $1EE8W
%patch $258FC $1E8EW

#Charging cycle
%patch $2591A $1EACW
%patch $25938 $1ECAW
%patch $25956 $1EE8W
%patch $25974 $1E8EW

#Corn throws to the...
%patch $8993 $1E16W #Right only

#Cache
%patch $23E86 $0127W #Corn cache start
%patch $23EB2 $0134W #Corn cache end

#Walking frames
%patch $25886 $0127W $0127W
%patch $25890 $000AW        #Animation speed
%patch $258A4 $0128W $0128W
%patch $258AE $000AW        #Animation speed
%patch $258C2 $0129W $0129W
%patch $258CC $000AW        #Animation speed
%patch $258E0 $012AW $012AW
%patch $258EA $000AW        #Animation speed

#Charging frames
%patch $258FE $0127W $0127W
%patch $25908 $0005W        #Animation speed
%patch $2591C $0128W $0128W
%patch $25926 $0005W        #Animation speed
%patch $2593A $0129W $0129W
%patch $25944 $0005W        #Animation speed
%patch $25958 $012AW $012AW
%patch $25962 $0005W        #Animation speed

#Tossing corn sprite
%patch $25976 $012AW $012AW
%patch $25980 $000AW        #Animation speed
%patch $25994 $012BW $012BW
%patch $2599E $0001W        #Animation speed
%patch $259B2 $012CW $012CW
%patch $259BC $000AW        #Animation speed

#Corn projectile
%patch $259D0 $012DW $012DW
%patch $259DA $0004W        #Animation speed
%patch $259EE $012DW $012DW
%patch $259F8 $0004W        #Animation speed


###################
#KING BOOBUS TUBER#
###################

#Boobus death smoke new sprites
%patch $25F34 $00A8W $00A8W
%patch $25F3E $0014W        #Animation speed
%patch $25F52 $00A8W $00A8W
%patch $25F5C $0014W        #Animation speed

#'Bomb' (Flower Power) explode animation
%patch $246BA $00A8W $00A8W
%patch $246C4 $0006W        #Animation speed
%patch $246D8 $00A8W $00A8W
%patch $246E2 $0006W        #Animation speed
%patch $246F6 $00A9W $00A9W
%patch $24700 $0006W        #Animation speed
%patch $24714 $00A9W $00A9W
%patch $2471E $0006W        #Animation speed
%patch $24732 $00AAW $00AAW
%patch $2473C $0006W        #Animation speed
%patch $24750 $00ABW $00ABW
%patch $2475A $0006W        #Animation speed


#################
#CANTELOUPE CART#
#################

#Pea sprite types
%patch $91FA $0C #Pea Pod

#Peapod doesn't spit
%patch $25DA0 $08680B22RL
%patch $25DBE $08680B22RL
%patch $25DDC $08680B22RL
%patch $25DFA $08680B22RL

#Pea pod walk
%patch $25D90 $0155W $0157W
%patch $25D9A $0005W        #Animation speed
%patch $25DAE $0156W $0158W
%patch $25DB8 $0005W        #Animation speed
%patch $25DCC $0155W $0157W
%patch $25DD6 $0005W        #Animation speed
%patch $25DEA $0156W $0158W
%patch $25DF4 $0005W        #Animation speed

#Pea Pod spawn height
%patch $920C $FFD0W #3 pixels upwards


###############
#WILTED FLOWER#
###############

#Wilted Flowers never recover
%patch $806A $5E $5D $CB

#No Wilted Flower appears
%patch $800B $1822W


##########
#AGARICUS#
##########

#Grape sprite type is platform-type
%patch $8537 $0C

#Cache - move animations
%patch $23E80 $012FW #Grape cache start
%patch $23EAC $0130W #Grape cache end

#Grape wait
%patch $25700 $012FW $012FW
%patch $2570A $0000W        #Animation speed

#Grape fall
%patch $2571E $0130W $0130W
%patch $25728 $0000W        #Animation speed

#Grape rise
%patch $2573C $012FW $012FW
%patch $25746 $001EW        #Animation speed

#Grape stop
%patch $2575A $0130W $0130W
%patch $25764 $0000W        #Animation speed

#Fallen grape doesn't rise
%patch $8639 $EB

#Grapes don't bounce
%patch $8646 $B8 $1CCCW  $50 $56 $0E $E8 $F856W  $83 $C4 $04 $EB $14

#New sound for falling
%patch $85E7 $10     #Sour Grape fall sound


######
#PEAR#
######

#Squasher don't jump or follow Keen, pushes him, can't be killed
%patch $792E  $19ACW
%patch $65DE  $073EW
%patch $25B48 $0000000L
%patch $25B66 $0000000L

#Pear walks
%patch $25B38 $0145W $0141W
%patch $25B42 $000BW        #Animation speed
%patch $25B56 $0146W $0142W
%patch $25B60 $000BW        #Animation speed

#Pear jumps
%patch $25B74 $0147W $0143W
%patch $25B7E $0009W        #Animation speed
%patch $25B92 $0148W $0144W
%patch $25B9C $0009W        #Animation speed

#When attacking Keen
%patch $8EFF $20E6W


#########
#KUMQUAT#
#########

#Horizontal Melon doesn't spit seed
%patch $25A1C $00000000L
%patch $25A3A $00000000L
%patch $25A58 $00000000L

#New sprite type
%patch $89F5 $14

#Left/right melon
%patch $25A0C $0137W $0135W
%patch $25A16 $0055W        #Animation speed


##########
#EGGPLANT#
##########

#Cache
%patch $23E78 $00F1W #Broccolash cache start
%patch $23EA4 $0100W #Broccolash cache end

#Adjust spawn height for taller sprite
%patch $81BB $FEC0W

#Broccolash attacks randomly -With sound
%patch $81EE $9A $16C40026RL     $3D $0028W  $7E $44 $5F $5E $5D $CB
%patch $823C $B8 $0010W  $50 $9A $10BB1282RL     $44 $44

#Broccolash uses only two frames when attacking
%patch $824A  $1A74W
%patch $2551E $19C0W
%patch $25512 $07C50587RL


#################
#WHITE ASPARAGUS#
#################

#New sprite type
%patch $8F5B $19

#Apel spawn height
%patch $8F6D $FF50W #16 pixels upwards

#Apel Walk
%patch $25BDE $07C5052BRL
%patch $25BFC $07C5052BRL
%patch $25C1A $07C5052BRL

#Apel walk
%patch $25BCE $014CW $0149W
%patch $25BD8 $0006W        #Animation speed
%patch $25BEC $014DW $014AW
%patch $25BF6 $0006W        #Animation speed
%patch $25C0A $014EW $014BW
%patch $25C14 $0006W        #Animation speed


###########
#BEAN SEED#
###########

#Asparagusto sprite type changed to Boobus-type to make it immortal, but still shootable
%patch $84F9 $17

#Asparagusto run
%patch $25688 $0113W $010FW
%patch $25692 $000AW        #Animation speed
%patch $256A6 $0113W $010FW
%patch $256B0 $000AW        #Animation speed
%patch $256C4 $0114W $0110W
%patch $256CE $000AW        #Animation speed
%patch $256E2 $0115W $0111W
%patch $256EC $000AW        #Animation speed


###################################################
#PASSIVE EYEBALL: COUNTERPART OF THE MAGIC EYEBALL#
###################################################

#Boobus Bomb is 10K point item
%patch $7787 $B8 $0007W  $50 $9A $10BB1282RL     $44 $44 $C7 $44 $20 $00D1W
             $B8 $2710W  $50 $9A $044D090ERL     $44 $44 $EB $1F

#Sprites used for each item:
%patch $25418 $00ACW #100
              $00AEW #200
              $00B0W #500
              $00B2W #1000
              $00B4W #2000
              $00B6W #5000
              $00B8W #1UP
              $00C5W #Key
              $00A2W #Flower Power
              $00BEW #Flower Pot
              $00C0W #Eye
              $00BAW #Boobus Bomb

#Item(s) that are special
%patch $814D $0A $73

#Change Keen's item collision in case of the Eye and the Key
%patch $7904 $192FW #Eye (At $7709)
%patch $790C $1889W #Key (At $77AF)


############
#HIGH SCORE#
############

#Default High Score data
%patch $28190 "Szemigi" $00
%patch $281CA $00002710L
%patch $281CE $0000W

%patch $281D0 "Levellass" $00
%patch $2820A $00002710L
%patch $2820E $0000W

%patch $28210 "Ceilick" $00
%patch $2824A $00002710L
%patch $2824E $0000W

%patch $28250 "Id Software, Inc." $00
%patch $2828A $00002710L
%patch $2828E $0000W

%patch $28290 "Softdisk Publishing" $00
%patch $282CA $00002710L
%patch $282CE $0000W

%patch $282D0 "Tom Hall" $00
%patch $2830A $00002710L
%patch $2830E $0000W

%patch $28310 "John Romero" $00
%patch $2834A $00002710L
%patch $2834E $0000W

%patch $28350 "John Carmack" $00
%patch $2838A $00002710L
%patch $2838E $0000W

%patch $28390 "Adrian Carmack" $00
%patch $283CA $00002710L
%patch $283CE $0000W

%patch $283D0 "Jason Blochowiak" $00
%patch $2840A $00002710L
%patch $2840E $0000W

#HS table has different background on Game Over
%patch $445D  $A1 $03A9W
%patch $5E6C  $A1 $03A9W
%patch $23E19 $0001W
%patch $4397  $B8 $0001W  $A3 $03A9W  $E9 $0109W
%patch $16C0D $B8 $0004W  $83 $3E $7126W  $00 $7C $03 $B8 $0002W  $A3 $03A9W
              $50 $9A $0CA5026BRL     $44 $44


######
#DOOR#
######

#Door spawn code; spawn height changing
%patch $7F73 $55 $8B $EC $33 $C0 $50 $9A $044D01C9RL     $44 $44 $8B $1E $3E
             $70 $C7 $07 $0003W  $8B $46 $06 $B1 $08 $D3 $E0 $89 $47 $0A $8B
             $46 $08 $D3 $E0 $05 $FD00W  $89 $47 $0C $C7 $47 $0E $0001W  $C7
             $47 $10 $FFFFW  $C7 $47 $06 $0000W  $B8 $1732W  $50 $FF $36 $3E
             $70 $9A $044D1212RL     $83 $C4 $04 $5D $CB

#Don't play Door blocking sound
%patch $7803 $EB $09


#################
#ENDING SEQUENCE#
#################

#Ending sequence has only two windows
%patch $5990 $CB

#First window text
%patch $24128 " The reign of the royal couple  " $0A
%patch $24149 " over New Tuberia was now a  " $0A
%patch $24167 "  fresh page in history.   " $0A
%patch $24183 " Keen walked through the dark  " $0A
%patch $241A3 "catacombs of the castle and" $0A
%patch $241BF "removed the evil potato presences" $0A
%patch $241E1 "from his mind.  He rescued  " $0A
%patch $241FE "all the adults, who had been" $0A
%patch $2421B "kept in chains, then ran to " $0A
%patch $24238 "the Dream Machine and pressed " $0A
%patch $24257 "the 'Off' switch. Silence. " $0A
%patch $24273 "    Everyone was freed!    " $0A
%patch $2428F "The celebrating adults deified" $0A
%patch $242AE " Keen, while his eyelids grew " $0A
%patch $242CD "heavy, and he quickly fell" $0A
%patch $242E8 "   asleep....  " $0A $00

#Second window text
%patch $242F9 "Billy woke up, rubbing his eyes" $0A
%patch $24319 "while looking around the room." $0A
%patch $24338 "No more veggies to" $0A
%patch $2434B "be seen, ever again." $0A
%patch $24360 " After he'd dressed, his  " $0A
%patch $2437B "mom entered the room." $0A $0A
%patch $24393 $22 "Hi, dear. Your father and I bought" $0A
%patch $243B7 "liver from the supermarket, so" $0A
%patch $243D6 "we're having that for supper" $0A
%patch $243F3 "tonight." $22 " Billy's mother said." $0A $0A
%patch $24413 $22 "I HATE liver!" $22 $0A $0A
%patch $24424 "THE END" $0A $0A $00


##############################
#NEW BOOBUS BOMB-TYPE MESSAGE#
##############################

#Note reading action
%patch $24BDC $0063W $0063W $0000W $0000W $0000W $0040W $0000W $0000W
              $05E81D64RL   $05E817FCRL   $05E81AE2RL   $0ED8W

#Modify Keen's code to trigger note (+2)
%patch $6C6C $74 $04 $7D $05 $EB $25 $E9 $0F3EW $C7 $44 $1E $116CW  $B8 $0008W
             $50 $9A $10BB1282RL     $44 $44 $B8 $0001W  $5F $5E $8B $E5 $5D $CB

#Move pole grip to here
%patch $7BB3 $8B $C7 $D3 $E0 $05 $FF80W  $2B $44 $0A $89 $44 $12 $A1 $7020W
             $B1 $05 $D3 $E0 $89 $44 $14 $89 $7C $44 $C7 $44 $06 $0000W  $C7
             $44 $1E $118AW  $B8 $0001W  $EB $02 $33 $C0 $5F $5E $8B $E5 $5D $CB

#Message window =$05E81D64RL
%patch $7BE4 $55 $8B $EC $4C $4C $56 $B8 $0009W  $50 $B8 $001CW  $50 $9A
         $11FA1C64RL     $83 $C4 $04 $8B $1E $8F3EW  $D1 $E3 $FF $B7 $012CW
             $9A $11FA1ABBRL     $44 $44 $9A $0CA508C0RL     $9A $0FE40C8ERL
                     $9A $0E450A00RL    $5E $8B $E5 $5D $CB

#Message pointer list
%patch $23B9E $0000W #Level 1 (NO MESSAGE)
              $0000W #Level 2 (NO MESSAGE)
              $014EW #Level 3
              $0000W #Level 4 (NO MESSAGE)
              $0000W #Level 5 (NO MESSAGE)
              $09E0W #Level 6 
              $0000W #Level 7 (NO MESSAGE)
              $01A9W #Level 8
              $02F0W #Level 9
              $0000W #Level 10 (NO MESSAGE)
              $0000W #Level 11 (NO MESSAGE)
              $4120W #Level 12
              $0000W #Level 13 (NO MESSAGE)
              $0218W #Level 14
              $0000W #Level 15 (NO MESSAGE)
              $2876W #Level 16

#Texts
%patch $23BBE $0A "There's a hidden dark cave on" $0A
              "the south-east." $0A $0A
              "You'll almost need everything" $0A
              "to visit it." $00
%patch $23C19 "There'll be two powerups in" $0A
              "New Tuberia:" $0A $0A
              "a) Passive Eyeball" $0A
              "b) Magic Eyeball" $0A $0A
              "Search for them!" $00
%patch $23C88 "Dangerous Dave says:" $0A
              $22 "I was on my way to save my" $0A
              "brother from Dr. Nemesis, but an" $0A
              "evil nurse has stabbed me in the" $0A
              "patient ward and I fell asleep." $0A
              "Then, I woke up in this cave, but" $0A
              "it's too dark in here. Help me!" $22 $00 
%patch $23D60 "Rover, the doggie says:" $0A
              $22 "Awooooooooo!" $0A
              "Woof! Woof!" $0A
              "Woof! Woof!" $0A
              "Woof! Woof!" $0A
	      "Woof! Woof!" $0A
              " Woof! Woof!" $22 $00
%patch $24450 "An adult slave's words:" $0A
	      $22 "Their Majesties will always" $0A
              "follow you if they see you," $0A
              "but you can always win time" $0A
	      "by running and hiding away" $0A
              "somewhere, where you can surely" $0A
              "defeat 'em from in case." $22 $00
%patch $262E6 $0A $22 "Get lost, you mad kid!" $0A
              "Firstly, you have fried my" $0A
              "colleagues with your weapon," $0A
              "then you dare to come back here." $0A
              "High time to pay for this!" $22 $00
%patch $27B90 "Mortimer McMire says:" $0A
              $22 "Be glad that it's only a" $0A
              "dream, otherwise you would" $0A
              "already be dead along with" $0A
              "all those wimp beings in the galaxy," $0A
              "mister THREE FOURTEEN!" $0A
              "Ah ha ha ha ha ha!" $22 $00


#################################
#NEW WINDOW BORDER FOR GAME OVER#
#################################

#Ignore low memory (Frees $3A45-$3AB8)
%patch $3A43 $EB $74

#Default window values
%patch $23C3B $0000W $0006W $0001W $0007W $0002W $0008W $0003W $0005W

#Text windows call default variables
%patch $13B51 $A1 $01CDW #Bottom left corner of box
%patch $13B70 $A1 $01CFW #Top of box
%patch $13B7E $A1 $01D1W #Bottom of box
%patch $13BA1 $A1 $01D3W #Top right corner of box
%patch $13BAF $A1 $01D5W #Bottom right corner of box
%patch $13BCB $A1 $01D7W #Left side of box
%patch $13BDB $A1 $01D9W #Right side of box
%patch $13B42 $A1 $01CBW #Top left corner of box
              $50 $57 $FF $76 $FE $9A $0CA5094BRL     $44 $44
%patch $13B65 $0A

#Window border alteration code =$00003A45RL
%patch $3A45 $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $9A $00003A78RL 
             $57 $56 $B8 $0019W  $2B $C7 $D1 $E8 $50 $B8 $0028W  $2B $C6 $D1 $E8 $50
             $9A $11FA1B27RL     $83 $C4 $08 $9A $00003A78RL     $5F $5E $5D $CB
%patch $3A78 $55 $8B $EC $83 $36 $01CBW  $1D $83 $36 $01CDW  $16 $83 $36 $01CFW
                 $17 $83 $36 $01D1W  $12 $83 $36 $01D3W  $19 $83 $36 $01D5W
             $1A $83 $36 $01D7W  $10 $83 $36 $01D9W  $1C $5D $CB

#Make windows use new border:
%patch $3CA8  $00003A45RL #Game over window



#######################################
#NEW WINDOW BORDER FOR ENDING SEQUENCE#
#######################################

#Ignore low memory (Frees $3A45-$3AB8)
%patch $3A43 $EB $74

#Default window values
%patch $23C3B $0000W $0006W $0001W $0007W $0002W $0008W $0003W $0005W

#Text windows call default variables
%patch $13B51 $A1 $01CDW #Bottom left corner of box
%patch $13B70 $A1 $01CFW #Top of box
%patch $13B7E $A1 $01D1W #Bottom of box
%patch $13BA1 $A1 $01D3W #Top right corner of box
%patch $13BAF $A1 $01D5W #Bottom right corner of box
%patch $13BCB $A1 $01D7W #Left side of box
%patch $13BDB $A1 $01D9W #Right side of box
%patch $13B42 $A1 $01CBW #Top left corner of box
              $50 $57 $FF $76 $FE $9A $0CA5094BRL     $44 $44
%patch $13B65 $0A

#Window border alteration code =$0CA5019BRL
%patch $CBEB $55 $8B $EC $56 $57 $8B $76 $06 $8B $7E $08 $9A $0CA501CERL
             $57 $56 $B8 $0019W  $2B $C7 $D1 $E8 $50 $B8 $0028W  $2B $C6 $D1 $E8 $50
             $9A $11FA1B27RL     $83 $C4 $08 $9A $0CA501CERL     $5F $5E $5D $CB
%patch $CC1E $55 $8B $EC $83 $36 $01CBW  $1C $83 $36 $01CDW  $17 $83 $36 $01CFW
                 $16 $83 $36 $01D1W  $13 $83 $36 $01D3W  $18 $83 $36 $01D5W
             $06 $83 $36 $01D7W  $0F $83 $36 $01D9W  $0A $5D $CB

#Make windows use new border:
%patch $5920  $0CA5019BRL #1st ending window
%patch $595F  $0CA5019BRL #2nd ending window

%end